"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Add the exports of the library here
 *
 */
exports.WebApp = require('./webapp/webapp-component').default;
exports.Middleware = require('./middleware/middleware-component').default;
exports.Route = require('./route/route-component').default;
exports.IsomorphicApp = require('./isomorphic/iso-component').default;
exports.Environment = require('./environment/environment-component').default;
exports.EnvValue = require('./environment/env-value-component').default;
exports.SinglePageApp = require('./spa/spa-component').default;
exports.ServiceOrientedApp = require('./soa/soa-component').default;
exports.DataLayer = require('./datalayer/datalayer-component').default;
exports.Entry = require('./datalayer/entry-component').default;
exports.Service = require('./service/service-component').default;
exports.withRequest = require('./components/attach-request').withRequest;
exports.AttachRequest = require('./components/attach-request').default;
exports.withIsomorphicState = require('./components/attach-isomorphic-state').withIsomorphicState;
exports.AttachIsomorphicState = require('./components/attach-isomorphic-state').default;
exports.SecuredEntry = require('./authentication/securedentry-component').default;
exports.Authentication = require('./authentication/authentication-component').default;
exports.AuthenticationProvider = require('./authentication/authentication-component').AuthenticationProvider;
exports.SecuredRoute = require('./authentication/securedroute-component').default;
exports.SecuredService = require('./authentication/securedservice-component').default;
exports.Identity = require('./identity/identity-component').default;
exports.AUTH_RESPONSE = require('./authentication/authentication-component').AUTH_RESPONSE;
exports.INFRASTRUCTURE_MODES = require('./libs/loader').INFRASTRUCTURE_MODES;
exports.loadInfrastructureComponent = require('./libs/loader').loadInfrastructureComponent;
exports.extractObject = require('./libs/loader').extractObject;
exports.loadConfigurationFromModule = require('./libs/loader').loadConfigurationFromModule;
exports.loadConfiguration = require('./libs/loader').loadConfiguration;
exports.IConfigParseResult = require('./libs/config-parse-result').IConfigParseResult;
exports.parseForPlugins = require('./libs/parser').parseForPlugins;
exports.extractConfigs = require('./libs/parser').extractConfigs;
exports.IPlugin = require('./libs/plugin').IPlugin;
exports.isWebApp = require('./webapp/webapp-component').isWebApp;
exports.isMiddleware = require('./middleware/middleware-component').isMiddleware;
exports.Types = require('./types').default;
exports.IConfiguration = require('./types/configuration').IConfiguration;
exports.IInfrastructure = require('./types/configuration').IInfrastructure;
exports.getChildrenArray = require('./libs').getChildrenArray;
exports.getStaticBucketName = require('./libs/iso-libs').getStaticBucketName;
exports.IEnvironmentArgs = require('./environment/environment-component').IEnvironmentArgs;
exports.PARSER_MODES = require('./libs/parser').PARSER_MODES;
exports.setEntry = require('./datalayer/datalayer-libs').setEntry;
exports.getEntryListQuery = require('./datalayer/datalayer-libs').getEntryListQuery;
exports.ddbListEntries = require('./datalayer/datalayer-libs').ddbListEntries;
exports.getEntry = require('./datalayer/datalayer-libs').getEntry;
exports.update = require('./datalayer/datalayer-libs').update;
exports.mutate = require('./datalayer/datalayer-libs').mutate;
exports.select = require('./datalayer/datalayer-libs').select;
exports.withDataLayer = require('./assets/attach-data-layer').withDataLayer;
exports.AttachDataLayer = require('./assets/attach-data-layer').default;
exports.serviceWithDataLayer = require('./assets/attach-data-layer').serviceWithDataLayer;
exports.getClientFilename = require('./libs/server-libs').getClientFilename;
exports.withRoutes = require('./assets/attach-routes').withRoutes;
exports.AttachRoutes = require('./assets/attach-routes').default;
exports.IRoute = require('./assets/routed-app').IRoute;
exports.withUser = require('./assets/attach-user').withUser;
exports.userLogout = require('./assets/attach-user').userLogout;
exports.AttachUser = require('./assets/attach-user').default;
exports.getUserId = require('./assets/attach-user').getUserId;
exports.getWebToken = require('./assets/attach-user').getWebToken;
exports.getBrowserId = require('./identity/identity-component').getBrowserId;
exports.withAuthCallback = require('./assets/attach-auth').withAuthCallback;
exports.getAuthCallback = require('./assets/attach-auth').getAuthCallback;
exports.AttachAuth = require('./assets/attach-auth').default;
exports.ForceLogin = require('./assets/force-login').default;
exports.callService = require('./assets/service-libs').callService;
exports.getServiceUrl = require('./assets/service-libs').getServiceUrl;
exports.getBasename = require('./libs/iso-libs').getBasename;
exports.fetchData = require('./libs/scripts-libs').fetchData;
//# sourceMappingURL=index.js.map